/** @file ci_char_traits.h */
#ifndef _CI_CHAR_TRAITS_H
#define _CI_CHAR_TRAITS_H 1

#include <string>
#include <ctype.h>
//#include "/usr/include/linux/string.h"
namespace bioinfo 
{

  /**
   * ci_char_traits : defines case insenstive "char traits"
   *
   * credits: this is ruthlessly and shamelessly ripped
   * from gcc3 documentation, which credits is source
   * as discussions relating to "guru of the week" articles
   * (www.gotw.ca)
   **/
  struct ci_char_traits : public std::char_traits<char>
                // just inherit all the other functions
                //  that we don't need to override
  {
    /**
     * @param c1 = input char 1
     * @param c2 = input char 2
     * @return calls tolower on char 1 and 2 returns true if equal
     */
    static bool eq( char c1, char c2 ) {
      return tolower(c1) == tolower(c2);
    }

    /**
     * @param c1 = input char 1
     * @param c2 = input char 2
     * @return calls tolower on char 1 and 2 returns true if not equal
     */
    static bool ne( char c1, char c2 ) {
      return tolower(c1) != tolower(c2);
    }

    /**
     * @param c1 = input char 1
     * @param c2 = input char 2
     * @return calls tolower on char 1 and 2 returns true if char 1 < char 2
     */
    static bool lt( char c1, char c2 ) {
      return tolower(c1) < tolower(c2);
    }

    static int compare( const char* s1,
                        const char* s2,
                        size_t n ) {
      return 0;
      //return strnicmp( s1, s2, n );
             // if available on your compiler,
             //  otherwise you can roll your own
    }

    static const char*
    find( const char* s, int n, char a ) {
      while( n-- > 0 && tolower(*s) != tolower(a) ) {
          ++s;
      }
      return s;
    }
  };

};

#endif // _CI_CHAR_TRAITS_H
